<?php
namespace Teknisa\CMP\Factories;

use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Cmp99000GeracaoAfPrevisaoFactory
{
  
  protected $entityManager;
  protected $connection;
    
  public function __construct($entityManager, $environment) {
    $this->entityManager  = $entityManager;
    $this->connection     = $entityManager->getConnection();
    $this->environment    = $environment;
  }
   

    public function realizaCommit(){
        $this->entityManager->commit();
    }

    public function realizaRollback(){
        $this->entityManager->rollBack();
    }

    private function executeQuery($sql, $params){
        
        $this->entityManager->beginTransaction();
      
  
        $std = $this->connection->prepare($sql);
     
        $std->execute($params);

        return $std->fetchAll();
    }

    public function getItmaPurPrecData($row)
    {
        try {
            $sql = "SELECT
    ITMAPURPREC.CDFORNITMAP                                                                        AS CDFORNECED,
    ITMAPURPREC.NRSEQITMAP                                                                         AS NRAPURPREC,
    'U'                                                                                            AS IDCHECK,
    FILIAL.CDFILIAL                                                                                CDFILSOLI,
    FILIAL.NMFILIAL,
    FILIAL.CDFILIAL
    || ' - '
    || FILIAL.NMFILIAL                                                                              DSFILIAL,
    ITMAPURPREC.CDCENTITMAP                                                                        CDFILLAN,
    NRSEQITMAP                                                                                     NRSOLICMP,
    PRODUTO.CDPRODUTO,
    DTENTRAPUT                                                                                     DTPROGENTR,
    QTACOMP                                                                                        QTSOLIPROD,
    PRODUTO.NMPRODUTO,
    PRODUTO.CDARVPROD,
    PRODUTO.SGUNIDADE,
    PRODUTO.CDARVPROD
    || ' - '
    || PRODUTO.NMPRODUTO                                                                           DSPRODUTO,
    CALC_ESTOQ_CONS(FILIAL.CDFILIAL, PRODUTO.CDPRODESTO, SYSDATE) / PRODUTO.VRFATOCONV             AS QTESTOQUE,
    MARCA.CDMARCA,
    MARCA.NMMARCA,
    MARCA.CDMARCA
    || ' - '
    || MARCA.NMMARCA                                                                               DSMARCA,
    VRPRECUNIAP                                                                                    VRCUSTO,
    ITMAPURPREC.NRORG,
    APURPRECO.QTDIAESTOQUE,
    ITMAPURPREC.QTCONSUMODIA,
    ITMAPURPREC.QTESTOQUE,
    ITMAPURPREC.QTDURACAEST,
    ITMAPURPREC.QTCONSUMODIASEST,
    ITMAPURPREC.QTITEMPED,
    ITMAPURPREC.QTPROGENTAF,
    ITMAPURPREC.QTENTRADAS,
    ITMAPURPREC.QTSAIDAS,
    ITMAPURPREC.QTACOMP * VRPRECUNIAP                                                                VRCUSTOTOTAL,
    FORNECEDOR.NRINSJURFORN
    || '-'
    || FORNECEDOR.NMFANTFORN                                                                        NMFANTFORN,
    ITMAPURPREC.CDEXPRODFORN
FROM
    ITMAPURPREC,
    PRODUTO,
    FILIAL,
    MARCA,
    APURPRECO,
    FORNECEDOR
WHERE
        ITMAPURPREC.CDCENTITMAP = APURPRECO.CDFILCENTCMP
    AND ITMAPURPREC.NRSEQITMAP = APURPRECO.NRAPURPREC
    AND ITMAPURPREC.CDCENTITMAP = :CDFILCENTCMP
    AND ITMAPURPREC.NRSEQITMAP = :NRAPURPREC
    AND ITMAPURPREC.CDFILIAP = FILIAL.CDFILIAL
    AND ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO
    AND ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA
    AND ( ( INSTR(:CDMARCA, ITMAPURPREC.CDMARCITMAP) > 0 )
          OR ( :CDMARCA = 'T' ) )
    AND ( ( INSTR(:CDFILIAL, FILIAL.CDFILIAL) > 0 )
          OR ( :CDFILIAL = 'T' ) )
    AND ( ( PRODUTO.CDARVPROD BETWEEN :CDPRODINI AND RPAD(:CDPRODFIN, 20, 'Z') )
          AND ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED
          OR ( :CDPRODFIN = 'T' ) )
    AND NOT EXISTS (
        SELECT
            1
        FROM
            AUTOFORNE,
            ITEMAUTF  I,
            PRODUTO   P
        WHERE
                I.CDFILDEST = AUTOFORNE.CDFILDEST
            AND I.CDFILLANC = AUTOFORNE.CDFILLANC
            AND I.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
            AND I.CDFILDEST = ITMAPURPREC.CDFILIAP
            AND I.DTENTRITMSOL = ITMAPURPREC.DTENTRAPUT
            AND I.CDPRODUTO = P.CDPRODUTO
            AND PRODUTO.CDPRODESTO = P.CDPRODESTO
            AND AUTOFORNE.NRSEQAPURAF = ITMAPURPREC.NRSEQITMAP
            AND AUTOFORNE.CDFORNECED = ITMAPURPREC.CDFORNITMAP
    )
ORDER BY
    FILIAL.CDFILIAL,
    CDARVPROD";

            $params = [
                //"CDFORNERELACAF" => $row["CDFORNERELACAF"] ?? null,
               // "CDFORNECED" => $row["CDFORNECED"] ?? null,
               "CDFILIAL" => $row["CDFILIAL"],
               // "CDCOMPRADOR" => $row["CDCOMPRADOR"],
               // "TIPOPREVISAO" => $row["TIPOPREVISAO"],
               // "CDSUBGRUPPROD" => $row["CDSUBGRUPPROD"][0] ?? null,
                "CDPRODINI" => $row["CDPRODINI"],
                "CDPRODFIN" => $row["CDPRODFIN"],
                "CDMARCA" => $row["CDMARCA"],
               // "DTNICIAL" => $row["DTNICIAL"],
               // "QTDIAESTOQUE" => $row["QTDIAESTOQUE"],
               // "DTENTREGA" => $row["DTENTREGA"] ,
               // "CDTIPOCUSTO" => $row["CDTIPOCUSTO"],
                "NRAPURPREC" => $row["NRAPURPREC"] ?? null,
                "CDFILCENTCMP" => $row["CDFILCENTCMP"] ?? null
            ];
            
            return  $this->executeQuery($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function gerarProcedure($params)
    {
        try{
            $rowsAffect = "";
            $procedure  = new StoredProcedure($this->connection, 'GERA_AF_POR_PREVISAO_COMPRA');

            $procedure->addParam(new Param('P_CDFILCENTCMP', Param::PARAM_INPUT, isset($params['CDFILCENTCMP']) ? $params['CDFILCENTCMP']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURPREC', Param::PARAM_INPUT, isset($params['NRAPURPREC']) ? $params['NRAPURPREC'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNERELACAF', Param::PARAM_INPUT, isset($params['CDFORNERELACAF']) ? $params['CDFORNERELACAF'] :  null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNECED', Param::PARAM_INPUT, isset($params['CDFORNECED']) ? $params['CDFORNECED'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, isset($params['CDFILIAL']) ? $params['CDFILIAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCOMPRADOR', Param::PARAM_INPUT, isset($params['CDCOMPRADOR']) ? $params['CDCOMPRADOR']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_TIPOPREVISAO', Param::PARAM_INPUT, isset($params['TIPOPREVISAO']) ? $params['TIPOPREVISAO']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSUBGRUPPROD', Param::PARAM_INPUT, isset($params['CDSUBGRUPPROD']) ? $params['CDSUBGRUPPROD'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODINI', Param::PARAM_INPUT, isset($params['CDPRODINI']) ? $params['CDPRODINI'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODFIN', Param::PARAM_INPUT, isset($params['CDPRODFIN']) ? $params['CDPRODFIN'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDMARCA', Param::PARAM_INPUT, isset($params['CDMARCA']) ? $params['CDMARCA']: null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, isset($params['DTINICIAL']) ? $params['DTINICIAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, isset($params['DTFINAL']) ? $params['DTFINAL'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTENTREGA', Param::PARAM_INPUT, isset($params['DTENTREGA']) ? $params['DTENTREGA'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDTIPOCUSTO', Param::PARAM_INPUT, isset($params['CDTIPOCUSTO']) ? $params['CDTIPOCUSTO'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTDIAESTOQUE', Param::PARAM_INPUT, isset($params['QTDIAESTOQUE']) ? $params['QTDIAESTOQUE'] : null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $this->environment->getCdOperador(), Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_ROWSAFFECT', Param::PARAM_OUTPUT, $rowsAffect, Param::PARAM_TYPE_STR));
            
            $rowsAffect = $procedure->execute();
            
            return $rowsAffect; 
        }
        catch(\Exception $e){
            throw $e;
        }
    }
  
}
