<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 08/04/14
 * Time: 13:46
 */

namespace Geral\Logic\Cadastros;


class Organizacao {

    public static function novo($nrorg, $nomeorg, $razaosocialempr, $nomeempr, $nrinsjurempr, $inscestadual,
                                $inscmunicipal, $cdpaisEmpresa, $sgestadoEmpresa, $cdmunicipioEmpresa, $razaosocialfili,
                                $nmfilial, $cnpj, $cdpais, $sgestado, $cdmunicipio, $cdcomunicaparc)
    {
         \Setforms2\Shared\Connection::getInstance()->beginTransaction();

        try {
            $organizacao = self::novaOrganizacao($nrorg, $nomeorg);
            $organizacao->persist();

            if ($razaosocialempr !== "") {
                tk_warning("Empresa cadastrada!");
                $empresa = \Geral\Logic\Cadastros\Organizacao\Estrutura\Empresa::nova(
                    $nrorg, $razaosocialempr, $nomeempr, $nrinsjurempr, $inscestadual, $inscmunicipal, $cdpaisEmpresa,
                    $sgestadoEmpresa, $cdmunicipioEmpresa, $cdcomunicaparc
                );
                $empresa->persist();
                \Setforms2\Shared\Registry::getEntityManager()->flush();
            }

            if ($razaosocialfili !== "") {
                tk_warning("Filial cadastrada!");
                $filial = \Geral\Logic\Cadastros\Organizacao\Estrutura\Filial::nova(
                    $nrorg, $razaosocialfili, $nmfilial, $cnpj, $inscestadual, $inscmunicipal, $empresa->getCdempresa(),
                    $cdcomunicaparc, $cdpais, $sgestado, $cdmunicipio
                );
                $filial->persist();
                \Setforms2\Shared\Registry::getEntityManager()->flush();
            }

            \Setforms2\Shared\Registry::getEntityManager()->commit();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            \Setforms2\Shared\Registry::getEntityManager()->rollback();
        }
    }

    /**
     * @param $nrorg
     * @param $nomeorg
     * @param $nrinscricaoorg
     * @return \Geral\Entities\Organizacao
     */
    private static function novaOrganizacao($nrorg, $nomeorg)
    {
        $organizacao = new \Geral\Entities\Organizacao();
        $organizacao->setNrinscricaoorg($organizacao->getRepository()->maxNrinscricaoorg());
        $organizacao->setNmrazsocialorg($nomeorg);
        $organizacao->setNmorganizacao($nomeorg);
        $organizacao->setNrorg($nrorg);
        $organizacao->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
        $organizacao->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $organizacao->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());

        return $organizacao;


    }

} 