/* Sistemas Integrados TECNISA

Nome: 9804_CDPTRGO_LOG_CDP_INSPETAPA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela INSPETAPA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              INSPETAPA, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_INSPETAPA
AFTER DELETE OR INSERT OR UPDATE
ON INSPETAPA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :NEW.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF :NEW.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;  

         IF :NEW.NRINSPETAPA IS NOT NULL THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:NEW.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF :NEW.CDEQUIPPRO IS NOT NULL THEN 
            V_DESC := V_DESC || 'CdEquiPro= ' || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdSetor= ' || :NEW.CDSETOR || ' ';
	 END IF;

         IF :NEW.QTHRINSPEXE IS NOT NULL THEN
           IF :NEW.QTHRINSPEXE < 1 THEN
               V_DESC := V_DESC || 'QtHrInspExe= ' || '0' || TO_CHAR(:NEW.QTHRINSPEXE) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrInspExe= ' || TO_CHAR(:NEW.QTHRINSPEXE) || ' ';
            END IF; 
	 END IF;

         IF :NEW.NRORDINSETAP IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdInsEtap= ' || :NEW.NRORDINSETAP || ' ';
	 END IF;

         IF :NEW.IDPROCINSET IS NOT NULL THEN
            V_DESC := V_DESC || 'IdProcInsEt= ' || :NEW.IDPROCINSET || ' ';
	 END IF;

         IF :NEW.NRORDIMPINS IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdImpIns= ' || :NEW.NRORDIMPINS || ' ' ;
	 END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.CDINSPECAO || :NEW.NRINSPETAPA;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF (:NEW.CDETAPAPROD <> :OLD.CDETAPAPROD) THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;  

         IF (:NEW.NRINSPETAPA <> :OLD.NRINSPETAPA) THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:NEW.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF (:NEW.CDEQUIPPRO <> :OLD.CDEQUIPPRO) THEN 
            V_DESC := V_DESC || 'CdEquiPro= ' || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF (NVL(:NEW.CDSETOR,'-1') <> NVL(:OLD.CDSETOR,'-1')) THEN
            V_DESC := V_DESC || 'CdSetor= ' || :NEW.CDSETOR || ' ';
	 END IF;

         IF (NVL(:NEW.QTHRINSPEXE,'-1') <> NVL(:OLD.QTHRINSPEXE,'-1')) THEN
           IF :NEW.QTHRINSPEXE < 1 THEN
               V_DESC := V_DESC || 'QtHrInspExe= ' || '0' || TO_CHAR(:NEW.QTHRINSPEXE) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrInspExe= ' || TO_CHAR(:NEW.QTHRINSPEXE) || ' ';
            END IF; 
	 END IF;

         IF (:NEW.NRORDINSETAP <> :OLD.NRORDINSETAP) THEN
            V_DESC := V_DESC || 'NrOrdInsEtap= ' || :NEW.NRORDINSETAP || ' ';
	 END IF;

         IF (NVL(:NEW.IDPROCINSET,'-1') <> NVL(:OLD.IDPROCINSET,'-1')) THEN
            V_DESC := V_DESC || 'IdProcInsEt= ' || :NEW.IDPROCINSET || ' ';
	 END IF;

         IF (:NEW.NRORDIMPINS <> :OLD.NRORDIMPINS) THEN
            V_DESC := V_DESC || 'NrOrdImpIns= ' || :NEW.NRORDIMPINS || ' ' ;
	 END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.CDINSPECAO || :NEW.NRINSPETAPA;

          V_IDTIPOOPER := '2';    
          V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:OLD.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :OLD.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:OLD.CDETAPAPROD,'') || ' ';
         END IF;

         IF :OLD.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;  

         IF :OLD.NRINSPETAPA IS NOT NULL THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:OLD.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF :OLD.CDEQUIPPRO IS NOT NULL THEN 
            V_DESC := V_DESC || 'CdEquiPro= ' || :OLD.CDEQUIPPRO || ' ';
         END IF;

         IF :OLD.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdSetor= ' || :OLD.CDSETOR || ' ';
	 END IF;

         IF :OLD.QTHRINSPEXE IS NOT NULL THEN
           IF :OLD.QTHRINSPEXE < 1 THEN
               V_DESC := V_DESC || 'QtHrInspExe= ' || '0' || TO_CHAR(:OLD.QTHRINSPEXE) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrInspExe= ' || TO_CHAR(:OLD.QTHRINSPEXE) || ' ';
            END IF; 
	 END IF;

         IF :OLD.NRORDINSETAP IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdInsEtap= ' || :OLD.NRORDINSETAP || ' ';
	 END IF;

         IF :OLD.IDPROCINSET IS NOT NULL THEN
            V_DESC := V_DESC || 'IdProcInsEt= ' || :OLD.IDPROCINSET || ' ';
	 END IF;

         IF :OLD.NRORDIMPINS IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdImpIns= ' || :OLD.NRORDIMPINS || ' ' ;
	 END IF;
         
      V_ITPESQ := :OLD.CDFILIAL   || :OLD.CDPRODUTO   || :OLD.CDPROCFABRIC || :OLD.CDETAPAPROD ||
                  :OLD.CDINSPECAO || :OLD.NRINSPETAPA;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;   

   IF NOT (V_DESC IS NULL) THEN      

      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                    VALUES  ('INSPETAPA', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);    
                        
   END IF;                     
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_INSPETAPA','5.07.001'); END;
/    
