export class FileUpload {
  public static async getFileContent(file: any) {
    const fileContent: any = await this.fileContent(file);
    return {
      content: fileContent,
      lastModified: file.lastModified,
      lastModifiedDate: file.lastModifiedDate,
      name: file.name,
      size: file.size,
      type: file.type,
      webkitRelativePath: file.webkitRelativePath,
    };
  }

  public static async fileContent(file: any) {
    return new Promise((resolve, reject) => {
      const reader = new FileReader();
      reader.readAsText(file); // eslint-disable-next-line
      reader.onload = async function (f) {
        if (f.target !== null) {
          const result = await FileUpload.splitFileContent(f.target.result);
          resolve(result);
        }
      };
      reader.onerror = (error) => reject(error);
    });
  }

  public static async splitFileContent(file: any) {
    const arrayFile: any[] = file.split('\r\n');
    const result: any[] = [];

    for (let a = 0; a < arrayFile.length; a += 1) {
      const content: any[] = [];
      const itens: any[] = [];
      let position = arrayFile[a].substring(0, 1);

      if (position === '1') {
        for (let b = a + 1; b <= arrayFile.length; b += 1) {
          if (arrayFile[b] === undefined || arrayFile[b] === null) {
            if (itens.length >= 1) {
              content.push(itens);
            }
          } else {
            position = arrayFile[b].substring(0, 1);

            if (position === '2') {
              const item = {
                CDOPERADOR: arrayFile[a].substring(1, 13),
                NRINSJURFORN: arrayFile[a].substring(13, 33),
                CDFILDEST: arrayFile[a].substring(33, 37),
                URS_NRAUTOFORN: arrayFile[a].substring(37, 48),
                CDARVPROD: arrayFile[b].substring(1, 20),
                QTPROGENTAF: arrayFile[b].substring(21, 36),
                VRPREUNIAF: arrayFile[b].substring(36, 51),
                CDMARCA: arrayFile[b].substring(51, 56),
                DTPROGENTAF: arrayFile[b].substring(56, 67),
                VRLINHA: b + 1,
              };

              itens.push(item);
            } else if (position === '1') {
              content.push(itens);
              break;
            }
          }
        }

        const data = {
          ITENS: content[0],
        };

        result.push(data);
      }
    }

    return result;
  }
}
